// UpdateControlPanelSettings.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define ADS_NUMBER "720020-12012"

#define REG_KEY_DIR TEXT("ControlPanel\\Volume")
#define REG_KEY     TEXT("Volume")

extern "C" void AudioUpdateFromRegistry ();

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
 	DWORD volume = 0;
	DWORD size = 0;
	DWORD type = 0;
	HKEY volumeKey;
	DWORD error = 0;

	RETAILMSG(1, (TEXT("\r\nUpdateControlPanelSettings  ")TEXT(ADS_NUMBER)TEXT(" built on ")TEXT(__DATE__)TEXT(" at ")TEXT(__TIME__)TEXT("\r\n")));

	// Update AudioRegistry Settings
	RETAILMSG(1, (TEXT("Updating audio settings. . . . . . ")));
	AudioUpdateFromRegistry();
	RETAILMSG(1, (TEXT("finshed\r\n")));

	// Set Volume
	RETAILMSG(1, (TEXT("Updating audio volume. . . . . . . ")));

	if((error = RegOpenKeyEx(HKEY_CURRENT_USER, REG_KEY_DIR, 0, NULL, &volumeKey)) != ERROR_SUCCESS)
	{
		RETAILMSG(1, (TEXT("Unable to open HKEY_CURRENT_USER\\%s  Error %d\r\n"), REG_KEY_DIR, error));
	}
	else
	{
		size = sizeof(volume);

		// Query Key Value
		if( (error = RegQueryValueEx(volumeKey, REG_KEY, NULL, &type, (byte*)&volume, &size)) != ERROR_SUCCESS)
		{
			RETAILMSG(1, (TEXT("Unable to open HKEY_CURRENT_USER\\%s\\%s  Error %d\r\n"), REG_KEY_DIR, REG_KEY, error));
		}
		else
		{
			// Set Volume
			waveOutSetVolume(NULL, volume);
			RETAILMSG(1, (TEXT("set volume to 0x%08x\r\n"), volume));

			// Close Key
			if( (error = RegCloseKey(volumeKey)) != ERROR_SUCCESS )
			{
				RETAILMSG(1, (TEXT("Unable to close HKEY_CURRENT_USER\\%s\\%s  Error %d\r\n"), REG_KEY_DIR, REG_KEY, error));
			}
			else
			{
				RETAILMSG(1, (TEXT("finshed\r\n")));
			}
		}

	}

	return 0;
}

